FSTATAT(2)

NAME
fstatat - get file status relative to a directory file descriptor

SYNOPSIS
#include <sys/stat.h>

int fstatat(int dirfd, const char *path, struct stat *buf, int flags);

DESCRIPTION
The fstatat() system call operates in exactly the same way as stat(2), except for the differences described in this manual page.

If the pathname given in path is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by stat(2) for a relative pathname).

If the pathname given in path is relative and dirfd is the special value AT_FDCWD, then path is interpreted relative to the current working directory of the calling process (like stat(2)).

If the pathname given in path is absolute, then dirfd is ignored.

flags can either be 0, or include the following flag:

AT_SYMLINK_NOFOLLOW
    If path is a symbolic link, do not dereference it: instead return information about the link itself, like lstat(2). (By default, fstatat() dereferences symbolic links (like stat(2).)

RETURN VALUE
On success, fstatat() returns 0. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for stat(2) can also occur for fstatat(). The following additional errors can occur for fstatat():

EBADF
    dirfd is not a valid file descriptor.

EINVAL
    Invalid flag specified in flags.

ENOTDIR
    path is a relative path and dirfd is a file descriptor referring to a file other than a directory.

NOTES
See openat(2) for an explanation of the need for fstatat().

CONFORMING TO
This system call is non-standard but is proposed for inclusion in a future revision of POSIX.1. A similar system call exists on Solaris.

VERSIONS
fstatat() was added to Linux in kernel 2.6.16.

SEE ALSO
openat(2), path_resolution(2), stat(2)